/*
 * Copyright (C) 2020-2021 Bareos GmbH & Co. KG
 * Copyright (C) 2010 SCALITY SA. All rights reserved.
 * http://www.scality.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY SCALITY SA ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL SCALITY SA OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of SCALITY SA.
 *
 * https://github.com/scality/Droplet
 */

#include "dropletp.h"
#include <droplet/s3/s3.h>

dpl_backend_t dpl_backend_s3
    = {"s3",
       .get_capabilities = dpl_s3_get_capabilities,
       .list_all_my_buckets = dpl_s3_list_all_my_buckets,
       .list_bucket = dpl_s3_list_bucket,
       .list_bucket_attrs = dpl_s3_list_bucket_attrs, /* WARNING, UNTESTED */
       .make_bucket = dpl_s3_make_bucket,
       .delete_bucket = dpl_s3_delete_bucket,
       .put = dpl_s3_put,
       .get = dpl_s3_get,
       .head = dpl_s3_head,
       .head_raw = dpl_s3_head_raw,
       .deletef = dpl_s3_delete,
       .delete_all = dpl_s3_delete_all,
       .genurl = dpl_s3_genurl,
       .copy = dpl_s3_copy,
       .stream_resume = dpl_s3_stream_resume,
       .stream_getmd = dpl_s3_stream_getmd,
       .stream_get = dpl_s3_stream_get,
       .stream_putmd = dpl_s3_stream_putmd,
       .stream_put = dpl_s3_stream_put,
       .stream_flush = dpl_s3_stream_flush};
